<?php namespace Ctct\Services; use Ctct\Util\RestClient; use Ctct\Util\Config; use Ctct\Components\EmailMarketing\Schedule; use Ctct\Components\EmailMarketing\TestSend; use Ctct\Components\Activities\Activity; use Ctct\Components\Activities\AddContacts; use Ctct\Components\Activities\RemoveFromLists; use Ctct\Components\Activities\ExportContacts; use Ctct\Components\Activities\ClearLists; class ActivityService extends BaseService { public function getActivities($accessToken, array $params = array()) { $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.activities'); $url = $this->buildUrl($baseUrl, $params); $response = parent::getRestClient()->get($url, parent::getHeaders($accessToken)); $jsonResponse = json_decode($response->body, true); $activities = array(); foreach ($jsonResponse as $activity) { $activities[] = Activity::create($activity); } return $activities; } public function getActivity($accessToken, $activityId) { $baseUrl = Config::get('endpoints.base_url') . sprintf(Config::get('endpoints.activity'), $activityId); $url = $this->buildUrl($baseUrl); $response = parent::getRestClient()->get($url, parent::getHeaders($accessToken)); return Activity::create(json_decode($response->body, true)); } public function createAddContactsActivity($accessToken, AddContacts $addContacts) { $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.add_contacts_activity'); $url = $this->buildUrl($baseUrl); $response = parent::getRestClient()->post($url, parent::getHeaders($accessToken), $addContacts->toJson()); return Activity::create(json_decode($response->body, true)); } public function createAddContactsActivityFromFile($accessToken, $fileName, $contents, $lists) { $eol = "\r\n"; $data = ''; $boundary=md5(time()); $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="file_name"' . $eol; $data .= 'Content-Type: text/plain' . $eol . $eol; $data .= $fileName . $eol; $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="lists"' . $eol; $data .= 'Content-Type: text/plain' . $eol . $eol; $data .= $lists . $eol; $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="data"' . $eol . $eol; $data .= $contents . $eol; $data .= "--" . $boundary . "--" . $eol; $headers = array( "Authorization: Bearer {$accessToken}", "Content-Type: multipart/form-data; boundary={$boundary}" ); $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.add_contacts_activity'); $url = $this->buildUrl($baseUrl); $response = parent::getRestClient()->post($url, $headers, $data); return Activity::create(json_decode($response->body, true)); } public function addClearListsActivity($accessToken, array $lists) { $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.clear_lists_activity'); $url = $this->buildUrl($baseUrl); $payload = array('lists' => $lists); $response = parent::getRestClient()->post($url, parent::getHeaders($accessToken), json_encode($payload)); return Activity::create(json_decode($response->body, true)); } public function addExportContactsActivity($accessToken, ExportContacts $exportContacts) { $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.export_contacts_activity'); $url = $this->buildUrl($baseUrl); $response = parent::getRestClient()->post($url, parent::getHeaders($accessToken), json_encode($exportContacts)); return Activity::create(json_decode($response->body, true)); } public function addRemoveContactsFromListsActivity($accessToken, array $emailAddresses, array $lists) { $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.remove_from_lists_activity'); $url = $this->buildUrl($baseUrl); $payload = array( 'import_data' => array(), 'lists' => $lists ); foreach ($emailAddresses as $emailAddress) { $payload['import_data'][] = array('email_addresses' => array($emailAddress)); } $response = parent::getRestClient()->post($url, parent::getHeaders($accessToken), json_encode($payload)); return Activity::create(json_decode($response->body, true)); } public function addRemoveContactsFromListsActivityFromFile($accessToken, $fileName, $contents, $lists) { $eol = "\r\n"; $data = ''; $boundary=md5(time()); $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="file_name"' . $eol; $data .= 'Content-Type: text/plain' . $eol . $eol; $data .= $fileName . $eol; $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="lists"' . $eol; $data .= 'Content-Type: text/plain' . $eol . $eol; $data .= $lists . $eol; $data .= '--' . $boundary . $eol; $data .= 'Content-Disposition: form-data; name="data"' . $eol . $eol; $data .= $contents . $eol; $data .= "--" . $boundary . "--" . $eol; $headers = array( "Authorization: Bearer {$accessToken}", "Content-Type: multipart/form-data; boundary={$boundary}" ); $baseUrl = Config::get('endpoints.base_url') . Config::get('endpoints.remove_from_lists_activity'); $url = $this->buildUrl($baseUrl); $response = parent::getRestClient()->post($url, $headers, $data); return Activity::create(json_decode($response->body, true)); } } 