<?php if (!function_exists('xmlrpc_encode_entitites')) { require_once("xmlrpc-3.0/lib/xmlrpc.inc"); } class iSDKException extends Exception { } class iSDK { static private $handle; public $logname = ''; public $loggingEnabled = 0; public function cfgCon($name, $key = "", $dbOn = "on") { $this->debug = (($key == 'on' || $key == 'off' || $key == 'kill' || $key == 'throw') ? $key : $dbOn); if ($key != "" && $key != "on" && $key != "off" && $key != 'kill' && $key != 'throw') { $this->key = $key; } else { throw new iSDKException('No API Credentials'); } if (!isset($appname)) { $appname = $name; } $this->client = new xmlrpc_client("https://$appname.infusionsoft.com/api/xmlrpc"); $this->client->return_type = "phpvals"; $this->client->setSSLVerifyPeer(TRUE); $this->client->setCaCertificate((__DIR__ != '__DIR__' ? __DIR__ : dirname(__FILE__)) . '/infusionsoft.pem'); $this->encKey = php_xmlrpc_encode($this->key); try { $connected = $this->dsGetSetting("Application", "enabled"); if (strpos($connected, 'ERROR') !== FALSE) { throw new iSDKException($connected); } } catch (iSDKException $e) { throw new iSDKException($e->getMessage()); } return true; } public function vendorCon($name, $user, $pass, $key = "", $dbOn = "on") { $this->debug = (($key == 'on' || $key == 'off' || $key == 'kill' || $key == 'throw') ? $key : $dbOn); if ($key != "" && $key != "on" && $key != "off" && $key != 'kill' && $key != 'throw') { $this->client = new xmlrpc_client("https://$name.infusionsoft.com/api/xmlrpc"); $this->key = $key; } else { throw new iSDKException('No API Credentials'); } $this->client->return_type = "phpvals"; $this->client->setSSLVerifyPeer(TRUE); $this->client->setCaCertificate((__DIR__ != '__DIR__' ? __DIR__ : dirname(__FILE__)) . '/infusionsoft.pem'); $carray = array( php_xmlrpc_encode($this->key), php_xmlrpc_encode($user), php_xmlrpc_encode(md5($pass))); $this->key = $this->methodCaller("DataService.getTemporaryKey", $carray); $this->encKey = php_xmlrpc_encode($this->key); try { $connected = $this->dsGetSetting("Application", "enabled"); } catch (iSDKException $e) { throw new iSDKException("Connection Failed"); } return TRUE; } public function appEcho($txt) { $carray = array( php_xmlrpc_encode($txt)); return $this->methodCaller("DataService.echo", $carray); } public function methodCaller($service, $callArray) { $call = new xmlrpcmsg($service, $callArray); if ($service != 'DataService.getTemporaryKey') { array_unshift($call->params, $this->encKey); } $now = time(); $start = microtime(); $result = $this->client->send($call); $stop = microtime(); if (!$result->faultCode()) { if ($this->loggingEnabled == 1) { $this->log(array('Method' => $service, 'Call' => $callArray, 'Start' => $start, 'Stop' => $stop, 'Now' => $now, 'Result' => $result, 'Error' => 'No', 'ErrorCode' => 'No Error Code Received')); } return $result->value(); } else { if ($this->loggingEnabled == 1) { $this->log(array('Method' => $service, 'Call' => $callArray, 'Start' => $start, 'Stop' => $stop, 'Now' => $now, 'Result' => $result, 'Error' => 'Yes', 'ErrorCode' => "ERROR: " . $result->faultCode() . " - " . $result->faultString())); } if ($this->debug == "kill") { die("ERROR: " . $result->faultCode() . " - " . $result->faultString()); } elseif ($this->debug == "on") { return "ERROR: " . $result->faultCode() . " - " . $result->faultString(); } elseif ($this->debug == "throw") { throw new iSDKException($result->faultString(), $result->faultCode()); } elseif ($this->debug == "off") { } } } public function getAffiliatesByProgram($programId) { $carray = array( php_xmlrpc_encode((int)$programId)); return $this->methodCaller("AffiliateProgramService.getAffiliatesByProgram", $carray); } public function getProgramsForAffiliate($affiliateId) { $carray = array( php_xmlrpc_encode((int)$affiliateId)); return $this->methodCaller("AffiliateProgramService.getProgramsForAffiliate", $carray); } public function getAffiliatePrograms() { $carray = array(); return $this->methodCaller("AffiliateProgramService.getAffiliatePrograms", $carray); } public function getResourcesForAffiliateProgram($programId) { $carray = array( php_xmlrpc_encode((int)$programId)); return $this->methodCaller("AffiliateProgramService.getResourcesForAffiliateProgram", $carray); } public function affClawbacks($affId, $startDate, $endDate) { $carray = array( php_xmlrpc_encode((int)$affId), php_xmlrpc_encode($startDate, array('auto_dates')), php_xmlrpc_encode($endDate, array('auto_dates'))); return $this->methodCaller("APIAffiliateService.affClawbacks", $carray); } public function affCommissions($affId, $startDate, $endDate) { $carray = array( php_xmlrpc_encode((int)$affId), php_xmlrpc_encode($startDate, array('auto_dates')), php_xmlrpc_encode($endDate, array('auto_dates'))); return $this->methodCaller("APIAffiliateService.affCommissions", $carray); } public function affPayouts($affId, $startDate, $endDate) { $carray = array( php_xmlrpc_encode((int)$affId), php_xmlrpc_encode($startDate, array('auto_dates')), php_xmlrpc_encode($endDate, array('auto_dates'))); return $this->methodCaller("APIAffiliateService.affPayouts", $carray); } public function affRunningTotals($affList) { $carray = array( php_xmlrpc_encode($affList)); return $this->methodCaller("APIAffiliateService.affRunningTotals", $carray); } public function affSummary($affList, $startDate, $endDate) { $carray = array( php_xmlrpc_encode($affList), php_xmlrpc_encode($startDate, array('auto_dates')), php_xmlrpc_encode($endDate, array('auto_dates'))); return $this->methodCaller("APIAffiliateService.affSummary", $carray); } public function getRedirectLinksForAffiliate($affiliateId) { $carray = array( php_xmlrpc_encode((int)$affiliateId)); return $this->methodCaller("AffiliateService.getRedirectLinksForAffiliate", $carray); } public function addCon($cMap, $optReason = "") { $carray = array( php_xmlrpc_encode($cMap, array('auto_dates'))); $conID = $this->methodCaller("ContactService.add", $carray); if (!empty($cMap['Email'])) { if ($optReason == "") { $this->optIn($cMap['Email']); } else { $this->optIn($cMap['Email'], $optReason); } } return $conID; } public function updateCon($cid, $cMap) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($cMap, array('auto_dates'))); return $this->methodCaller("ContactService.update", $carray); } public function mergeCon($cid, $dcid) { $carray = array( php_xmlrpc_encode($cid), php_xmlrpc_encode($dcid)); return $this->methodCaller("ContactService.merge", $carray); } public function findByEmail($eml, $fMap) { $carray = array( php_xmlrpc_encode($eml), php_xmlrpc_encode($fMap)); return $this->methodCaller("ContactService.findByEmail", $carray); } public function loadCon($cid, $rFields) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($rFields)); return $this->methodCaller("ContactService.load", $carray); } public function grpAssign($cid, $gid) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$gid)); return $this->methodCaller("ContactService.addToGroup", $carray); } public function grpRemove($cid, $gid) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$gid)); return $this->methodCaller("ContactService.removeFromGroup", $carray); } public function resumeCampaignForContact($cid, $sequenceId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$sequenceId)); return $this->methodCaller("ContactService.resumeCampaignForContact", $carray); } public function campAssign($cid, $campId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$campId)); return $this->methodCaller("ContactService.addToCampaign", $carray); } public function getNextCampaignStep($cid, $campId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$campId)); return $this->methodCaller("ContactService.getNextCampaignStep", $carray); } public function getCampaigneeStepDetails($cid, $stepId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$stepId)); return $this->methodCaller("ContactService.getCampaigneeStepDetails", $carray); } public function rescheduleCampaignStep($cidList, $campId) { $carray = array( php_xmlrpc_encode($cidList), php_xmlrpc_encode((int)$campId)); return $this->methodCaller("ContactService.rescheduleCampaignStep", $carray); } public function campRemove($cid, $campId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$campId)); return $this->methodCaller("ContactService.removeFromCampaign", $carray); } public function campPause($cid, $campId) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$campId)); return $this->methodCaller("ContactService.pauseCampaign", $carray); } public function runAS($cid, $aid) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode((int)$aid)); return $this->methodCaller("ContactService.runActionSequence", $carray); } public function applyActivityHistoryTemplate($contactId, $historyId, $userId) { $carray = array( php_xmlrpc_encode((int)$contactId), php_xmlrpc_encode((int)$historyId), php_xmlrpc_encode((int)$userId)); return $this->methodCaller("ContactService.applyActivityHistoryTemplate", $carray); } public function getActivityHistoryTemplateMap() { $carray = array(); return $this->methodCaller("ContactService.getActivityHistoryTemplateMap", $carray); } public function addWithDupCheck($cMap, $checkType) { $carray = array( php_xmlrpc_encode($cMap, array('auto_dates')), php_xmlrpc_encode($checkType)); return $this->methodCaller("ContactService.addWithDupCheck", $carray); } public function requestCcSubmissionToken($contactId, $successUrl, $failureUrl) { $carray = array( php_xmlrpc_encode((int)$contactId), php_xmlrpc_encode((string)$successUrl), php_xmlrpc_encode((string)$failureUrl)); return $this->methodCaller("CreditCardSubmissionService.requestSubmissionToken", $carray); } public function requestCreditCardId($token) { $carray = array( php_xmlrpc_encode($token)); return $this->methodCaller("CreditCardSubmissionService.requestCreditCardId", $carray); } public function dsGetSetting($module, $setting) { $carray = array( php_xmlrpc_encode($module), php_xmlrpc_encode($setting)); return $this->methodCaller("DataService.getAppSetting", $carray); } public function dsAdd($tName, $iMap) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode($iMap, array('auto_dates'))); return $this->methodCaller("DataService.add", $carray); } public function dsAddWithImage($tName, $iMap) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode($iMap, array('auto_dates', 'auto_base64'))); return $this->methodCaller("DataService.add", $carray); } public function dsDelete($tName, $id) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$id)); return $this->methodCaller("DataService.delete", $carray); } public function dsUpdate($tName, $id, $iMap) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$id), php_xmlrpc_encode($iMap, array('auto_dates'))); return $this->methodCaller("DataService.update", $carray); } public function dsUpdateWithImage($tName, $id, $iMap) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$id), php_xmlrpc_encode($iMap, array('auto_dates', 'auto_base64'))); return $this->methodCaller("DataService.update", $carray); } public function dsLoad($tName, $id, $rFields) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$id), php_xmlrpc_encode($rFields)); return $this->methodCaller("DataService.load", $carray); } public function dsFind($tName, $limit, $page, $field, $value, $rFields) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$limit), php_xmlrpc_encode((int)$page), php_xmlrpc_encode($field), php_xmlrpc_encode($value), php_xmlrpc_encode($rFields)); return $this->methodCaller("DataService.findByField", $carray); } public function dsQuery($tName, $limit, $page, $query, $rFields) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$limit), php_xmlrpc_encode((int)$page), php_xmlrpc_encode($query, array('auto_dates')), php_xmlrpc_encode($rFields)); return $this->methodCaller("DataService.query", $carray); } public function dsQueryOrderBy($tName, $limit, $page, $query, $rFields, $orderByField, $ascending = TRUE) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode((int)$limit), php_xmlrpc_encode((int)$page), php_xmlrpc_encode($query, array('auto_dates')), php_xmlrpc_encode($rFields), php_xmlrpc_encode($orderByField), php_xmlrpc_encode((bool)$ascending)); return $this->methodCaller("DataService.query", $carray); } public function dsCount($tName, $query) { $carray = array( php_xmlrpc_encode($tName), php_xmlrpc_encode($query, array('auto_dates')) ); return $this->methodCaller("DataService.count", $carray); } public function addCustomField($context, $displayName, $dataType, $headerID) { $carray = array( php_xmlrpc_encode($context), php_xmlrpc_encode($displayName), php_xmlrpc_encode($dataType), php_xmlrpc_encode((int)$headerID)); return $this->methodCaller("DataService.addCustomField", $carray); } public function authenticateUser($userName, $password) { $password = strtolower(md5($password)); $carray = array( php_xmlrpc_encode($userName), php_xmlrpc_encode($password)); return $this->methodCaller("DataService.authenticateUser", $carray); } public function updateCustomField($fieldId, $fieldValues) { $carray = array( php_xmlrpc_encode((int)$fieldId), php_xmlrpc_encode($fieldValues)); return $this->methodCaller("DataService.updateCustomField", $carray); } public function addFreeTrial($name, $description, $freeTrialDays, $hidePrice, $subscriptionPlanId) { $carray = array( php_xmlrpc_encode((string)$name), php_xmlrpc_encode((string)$description), php_xmlrpc_encode((int)$freeTrialDays), php_xmlrpc_encode((int)$hidePrice), php_xmlrpc_encode((int)$subscriptionPlanId)); return $this->methodCaller("DiscountService.addFreeTrial", $carray); } public function getFreeTrial($trialId) { $carray = array( php_xmlrpc_encode((int)$trialId)); return $this->methodCaller("DiscountService.getFreeTrial", $carray); } public function addOrderTotalDiscount($name, $description, $applyDiscountToCommission, $percentOrAmt, $amt, $payType) { $carray = array( php_xmlrpc_encode((string)$name), php_xmlrpc_encode((string)$description), php_xmlrpc_encode((int)$applyDiscountToCommission), php_xmlrpc_encode((int)$percentOrAmt), php_xmlrpc_encode($amt), php_xmlrpc_encode($payType)); return $this->methodCaller("DiscountService.addOrderTotalDiscount", $carray); } public function getOrderTotalDiscount($id) { $carray = array( php_xmlrpc_encode((int)$id)); return $this->methodCaller("DiscountService.getOrderTotalDiscount", $carray); } public function addCategoryDiscount($name, $description, $applyDiscountToCommission, $amt) { $carray = array( php_xmlrpc_encode((string)$name), php_xmlrpc_encode((string)$description), php_xmlrpc_encode((int)$applyDiscountToCommission), php_xmlrpc_encode($amt)); return $this->methodCaller("DiscountService.addCategoryDiscount", $carray); } public function getCategoryDiscount($id) { $carray = array( php_xmlrpc_encode((int)$id)); return $this->methodCaller("DiscountService.getCategoryDiscount", $carray); } public function addCategoryAssignmentToCategoryDiscount($categoryDiscountId, $productCategoryId) { $carray = array( php_xmlrpc_encode((int)$categoryDiscountId), php_xmlrpc_encode((int)$productCategoryId)); return $this->methodCaller("DiscountService.addCategoryAssignmentToCategoryDiscount", $carray); } public function getCategoryAssignmentsForCategoryDiscount($id) { $carray = array( php_xmlrpc_encode((int)$id)); return $this->methodCaller("DiscountService.getCategoryAssignmentsForCategoryDiscount", $carray); } public function addProductTotalDiscount($name, $description, $applyDiscountToCommission, $productId, $percentOrAmt, $amt) { $carray = array( php_xmlrpc_encode((string)$name), php_xmlrpc_encode((string)$description), php_xmlrpc_encode((int)$applyDiscountToCommission), php_xmlrpc_encode((int)$productId), php_xmlrpc_encode((int)$percentOrAmt), php_xmlrpc_encode($amt)); return $this->methodCaller("DiscountService.addProductTotalDiscount", $carray); } public function getProductTotalDiscount($id) { $carray = array( php_xmlrpc_encode((int)$id)); return $this->methodCaller("DiscountService.getProductTotalDiscount", $carray); } public function addShippingTotalDiscount($name, $description, $applyDiscountToCommission, $percentOrAmt, $amt) { $carray = array( php_xmlrpc_encode((string)$name), php_xmlrpc_encode((string)$description), php_xmlrpc_encode((int)$applyDiscountToCommission), php_xmlrpc_encode((int)$percentOrAmt), php_xmlrpc_encode($amt)); return $this->methodCaller("DiscountService.addShippingTotalDiscount", $carray); } public function getShippingTotalDiscount($id) { $carray = array( php_xmlrpc_encode((int)$id)); return $this->methodCaller("DiscountService.getShippingTotalDiscount", $carray); } public function attachEmail($cId, $fromName, $fromAddress, $toAddress, $ccAddresses, $bccAddresses, $contentType, $subject, $htmlBody, $txtBody, $header, $strRecvdDate, $strSentDate, $emailSentType = 1) { $carray = array( php_xmlrpc_encode((int)$cId), php_xmlrpc_encode($fromName), php_xmlrpc_encode($fromAddress), php_xmlrpc_encode($toAddress), php_xmlrpc_encode($ccAddresses), php_xmlrpc_encode($bccAddresses), php_xmlrpc_encode($contentType), php_xmlrpc_encode($subject), php_xmlrpc_encode($htmlBody), php_xmlrpc_encode($txtBody), php_xmlrpc_encode($header), php_xmlrpc_encode($strRecvdDate), php_xmlrpc_encode($strSentDate), php_xmlrpc_encode($emailSentType)); return $this->methodCaller("APIEmailService.attachEmail", $carray); } public function getAvailableMergeFields($mergeContext) { $carray = array( php_xmlrpc_encode($mergeContext)); return $this->methodCaller("APIEmailService.getAvailableMergeFields", $carray); } public function sendEmail($conList, $fromAddress, $toAddress, $ccAddresses, $bccAddresses, $contentType, $subject, $htmlBody, $txtBody) { $carray = array( php_xmlrpc_encode($conList), php_xmlrpc_encode($fromAddress), php_xmlrpc_encode($toAddress), php_xmlrpc_encode($ccAddresses), php_xmlrpc_encode($bccAddresses), php_xmlrpc_encode($contentType), php_xmlrpc_encode($subject), php_xmlrpc_encode($htmlBody), php_xmlrpc_encode($txtBody)); return $this->methodCaller("APIEmailService.sendEmail", $carray); } public function sendTemplate($conList, $template) { $carray = array( php_xmlrpc_encode($conList), php_xmlrpc_encode($template)); return $this->methodCaller("APIEmailService.sendEmail", $carray); } public function createEmailTemplate($title, $userID, $fromAddress, $toAddress, $ccAddresses, $bccAddresses, $contentType, $subject, $htmlBody, $txtBody) { $carray = array( php_xmlrpc_encode($title), php_xmlrpc_encode($category = ''), php_xmlrpc_encode($fromAddress), php_xmlrpc_encode($toAddress), php_xmlrpc_encode($ccAddresses), php_xmlrpc_encode($bccAddresses), php_xmlrpc_encode($subject), php_xmlrpc_encode($txtBody), php_xmlrpc_encode($htmlBody), php_xmlrpc_encode($contentType), php_xmlrpc_encode($mergeContext = 'Contact')); return $this->methodCaller("APIEmailService.addEmailTemplate", $carray); } public function addEmailTemplate($title, $category, $fromAddress, $toAddress, $ccAddresses, $bccAddresses, $subject, $txtBody, $htmlBody, $contentType, $mergeContext) { $carray = array( php_xmlrpc_encode($title), php_xmlrpc_encode($category), php_xmlrpc_encode($fromAddress), php_xmlrpc_encode($toAddress), php_xmlrpc_encode($ccAddresses), php_xmlrpc_encode($bccAddresses), php_xmlrpc_encode($subject), php_xmlrpc_encode($txtBody), php_xmlrpc_encode($htmlBody), php_xmlrpc_encode($contentType), php_xmlrpc_encode($mergeContext)); return $this->methodCaller("APIEmailService.addEmailTemplate", $carray); } public function getEmailTemplate($templateId) { $carray = array( php_xmlrpc_encode((int)$templateId)); return $this->methodCaller("APIEmailService.getEmailTemplate", $carray); } public function updateEmailTemplate($templateID, $title, $categories, $fromAddress, $toAddress, $ccAddress, $bccAddress, $subject, $textBody, $htmlBody, $contentType, $mergeContext) { $carray = array( php_xmlrpc_encode((int)$templateID), php_xmlrpc_encode($title), php_xmlrpc_encode($categories), php_xmlrpc_encode($fromAddress), php_xmlrpc_encode($toAddress), php_xmlrpc_encode($ccAddress), php_xmlrpc_encode($bccAddress), php_xmlrpc_encode($subject), php_xmlrpc_encode($textBody), php_xmlrpc_encode($htmlBody), php_xmlrpc_encode($contentType), php_xmlrpc_encode($mergeContext)); return $this->methodCaller("APIEmailService.updateEmailTemplate", $carray); } public function optStatus($email) { $carray = array( php_xmlrpc_encode($email)); return $this->methodCaller("APIEmailService.getOptStatus", $carray); } public function optIn($email, $reason = 'Contact Was Opted In through the API') { $carray = array( php_xmlrpc_encode($email), php_xmlrpc_encode($reason)); return $this->methodCaller("APIEmailService.optIn", $carray); } public function optOut($email, $reason = 'Contact Was Opted Out through the API') { $carray = array( php_xmlrpc_encode($email), php_xmlrpc_encode($reason)); return $this->methodCaller("APIEmailService.optOut", $carray); } public function getFile($fileID) { $carray = array( php_xmlrpc_encode((int)$fileID)); $result = $this->methodCaller("FileService.getFile", $carray); return $result; } public function uploadFile($fileName, $base64Enc, $cid = 0) { $result = 0; if ($cid == 0) { $carray = array( php_xmlrpc_encode($fileName), php_xmlrpc_encode($base64Enc)); $result = $this->methodCaller("FileService.uploadFile", $carray); } else { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($fileName), php_xmlrpc_encode($base64Enc)); $result = $this->methodCaller("FileService.uploadFile", $carray); } return $result; } public function replaceFile($fileID, $base64Enc) { $carray = array( php_xmlrpc_encode((int)$fileID), php_xmlrpc_encode($base64Enc)); $result = $this->methodCaller("FileService.replaceFile", $carray); return $result; } public function renameFile($fileID, $fileName) { $carray = array( php_xmlrpc_encode((int)$fileID), php_xmlrpc_encode($fileName)); $result = $this->methodCaller("FileService.renameFile", $carray); return $result; } public function getDownloadUrl($fileID) { $carray = array( php_xmlrpc_encode((int)$fileID)); $result = $this->methodCaller("FileService.getDownloadUrl", $carray); return $result; } public function achieveGoal($integration, $callName, $contactId) { $carray = array( php_xmlrpc_encode((string)$integration), php_xmlrpc_encode((string)$callName), php_xmlrpc_encode((int)$contactId)); return $this->methodCaller("FunnelService.achieveGoal", $carray); } public function deleteInvoice($Id) { $carray = array( php_xmlrpc_encode((int)$Id)); return $this->methodCaller("InvoiceService.deleteInvoice", $carray); } public function deleteSubscription($Id) { $carray = array( php_xmlrpc_encode((int)$Id)); return $this->methodCaller("InvoiceService.deleteSubscription", $carray); } public function getPayments($Id) { $carray = array( php_xmlrpc_encode((int)$Id)); return $this->methodCaller("InvoiceService.getPayments", $carray); } public function setInvoiceSyncStatus($Id, $syncStatus) { $carray = array( php_xmlrpc_encode((int)$Id), php_xmlrpc_encode($syncStatus)); return $this->methodCaller("InvoiceService.setInvoiceSyncStatus", $carray); } public function setPaymentSyncStatus($Id, $Status) { $carray = array( php_xmlrpc_encode((int)$Id), php_xmlrpc_encode($Status)); return $this->methodCaller("InvoiceService.setPaymentSyncStatus", $carray); } public function getPluginStatus($className) { $carray = array( php_xmlrpc_encode($className)); return $this->methodCaller("InvoiceService.getPluginStatus", $carray); } public function getAllPaymentOptions() { $carray = array(); return $this->methodCaller("InvoiceService.getAllPaymentOptions", $carray); } public function manualPmt($invId, $amt, $payDate, $payType, $payDesc, $bypassComm) { $carray = array( php_xmlrpc_encode((int)$invId), php_xmlrpc_encode($amt), php_xmlrpc_encode($payDate, array('auto_dates')), php_xmlrpc_encode($payType), php_xmlrpc_encode($payDesc), php_xmlrpc_encode($bypassComm)); return $this->methodCaller("InvoiceService.addManualPayment", $carray); } public function commOverride($invId, $affId, $prodId, $percentage, $amt, $payType, $desc, $date) { $carray = array( php_xmlrpc_encode((int)$invId), php_xmlrpc_encode((int)$affId), php_xmlrpc_encode((int)$prodId), php_xmlrpc_encode($percentage), php_xmlrpc_encode($amt), php_xmlrpc_encode($payType), php_xmlrpc_encode($desc), php_xmlrpc_encode($date, array('auto_dates'))); return $this->methodCaller("InvoiceService.addOrderCommissionOverride", $carray); } public function addOrderItem($ordId, $prodId, $type, $price, $qty, $desc, $notes) { $carray = array( php_xmlrpc_encode((int)$ordId), php_xmlrpc_encode((int)$prodId), php_xmlrpc_encode((int)$type), php_xmlrpc_encode($price), php_xmlrpc_encode($qty), php_xmlrpc_encode($desc), php_xmlrpc_encode($notes)); return $this->methodCaller("InvoiceService.addOrderItem", $carray); } public function payPlan($ordId, $aCharge, $ccId, $merchId, $retry, $retryAmt, $initialPmt, $initialPmtDate, $planStartDate, $numPmts, $pmtDays) { $carray = array( php_xmlrpc_encode((int)$ordId), php_xmlrpc_encode($aCharge), php_xmlrpc_encode((int)$ccId), php_xmlrpc_encode((int)$merchId), php_xmlrpc_encode((int)$retry), php_xmlrpc_encode((int)$retryAmt), php_xmlrpc_encode($initialPmt), php_xmlrpc_encode($initialPmtDate, array('auto_dates')), php_xmlrpc_encode($planStartDate, array('auto_dates')), php_xmlrpc_encode((int)$numPmts), php_xmlrpc_encode((int)$pmtDays)); return $this->methodCaller("InvoiceService.addPaymentPlan", $carray); } public function addRecurring($cid, $allowDup, $progId, $merchId, $ccId, $affId, $daysToCharge) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($allowDup), php_xmlrpc_encode((int)$progId), php_xmlrpc_encode((int)$merchId), php_xmlrpc_encode((int)$ccId), php_xmlrpc_encode((int)$affId), php_xmlrpc_encode($daysToCharge)); return $this->methodCaller("InvoiceService.addRecurringOrder", $carray); } public function addRecurringAdv($cid, $allowDup, $progId, $qty, $price, $allowTax, $merchId, $ccId, $affId, $daysToCharge) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($allowDup), php_xmlrpc_encode((int)$progId), php_xmlrpc_encode($qty), php_xmlrpc_encode($price), php_xmlrpc_encode($allowTax), php_xmlrpc_encode($merchId), php_xmlrpc_encode((int)$ccId), php_xmlrpc_encode((int)$affId), php_xmlrpc_encode($daysToCharge)); return $this->methodCaller("InvoiceService.addRecurringOrder", $carray); } public function amtOwed($invId) { $carray = array( php_xmlrpc_encode((int)$invId)); return $this->methodCaller("InvoiceService.calculateAmountOwed", $carray); } public function getInvoiceId($orderId) { $carray = array( php_xmlrpc_encode((int)$orderId)); return $this->methodCaller("InvoiceService.getInvoiceId", $carray); } public function getOrderId($invoiceId) { $carray = array( php_xmlrpc_encode((int)$invoiceId)); return $this->methodCaller("InvoiceService.getOrderId", $carray); } public function chargeInvoice($invId, $notes, $ccId, $merchId, $bypassComm) { $carray = array( php_xmlrpc_encode((int)$invId), php_xmlrpc_encode($notes), php_xmlrpc_encode((int)$ccId), php_xmlrpc_encode((int)$merchId), php_xmlrpc_encode($bypassComm)); return $this->methodCaller("InvoiceService.chargeInvoice", $carray); } public function blankOrder($conId, $desc, $oDate, $leadAff, $saleAff) { $carray = array( php_xmlrpc_encode((int)$conId), php_xmlrpc_encode($desc), php_xmlrpc_encode($oDate, array('auto_dates')), php_xmlrpc_encode((int)$leadAff), php_xmlrpc_encode((int)$saleAff)); return $this->methodCaller("InvoiceService.createBlankOrder", $carray); } public function recurringInvoice($rid) { $carray = array( php_xmlrpc_encode((int)$rid)); return $this->methodCaller("InvoiceService.createInvoiceForRecurring", $carray); } public function locateCard($cid, $last4) { $carray = array( php_xmlrpc_encode((int)$cid), php_xmlrpc_encode($last4)); return $this->methodCaller("InvoiceService.locateExistingCard", $carray); } public function validateCard($creditCard) { $creditCard = is_array($creditCard) ? $creditCard : (int)$creditCard; $carray = array( php_xmlrpc_encode($creditCard)); return $this->methodCaller("InvoiceService.validateCreditCard", $carray); } public function updateSubscriptionNextBillDate($subscriptionId, $nextBillDate) { $carray = array( php_xmlrpc_encode((int)$subscriptionId), php_xmlrpc_encode($nextBillDate, array('auto_dates'))); return $this->methodCaller("InvoiceService.updateJobRecurringNextBillDate", $carray); } public function recalculateTax($invoiceId) { $carray = array( php_xmlrpc_encode((int)$invoiceId)); return $this->methodCaller("InvoiceService.recalculateTax", $carray); } public function infuDate($dateStr, $dateFrmt = 'US') { $dArray = date_parse($dateStr); if ($dArray['error_count'] < 1) { $tStamp = mktime($dArray['hour'], $dArray['minute'], $dArray['second'], $dArray['month'], $dArray['day'], $dArray['year']); if ($dateFrmt == 'UK') { setlocale(LC_ALL, 'en_GB'); return date('Y-d-m\TH:i:s', $tStamp); } else { return date('Ymd\TH:i:s', $tStamp); } } else { foreach ($dArray['errors'] as $err) { echo "ERROR: " . $err . "<br />"; } die("The above errors prevented the application from executing properly."); } } public function enableLogging($log) { $this->loggingEnabled = $log; } static protected function getHandle($logname) { if (!is_resource(self::$handle)) { self::$handle = fopen($logname, 'a+'); } return self::$handle; } private function log($data) { $logdata = $data; if ($this->logname == '') { $logname = dirname(__FILE__) . '/apilog.csv'; } else { $logname = $this->logname; } if (!file_exists($logname)) { $this->getHandle($logname); fputcsv(self::$handle, array('Date', 'Method', 'Call', 'Start Time', 'Stop Time', 'Execution Time', 'Result', 'Error', 'Error Code')); } else { $this->getHandle($logname); } if (isset($logdata['Call'][0]->me['string'])) { if ($logdata['Call'][0]->me['string'] == 'CreditCard') { unset($logdata['Call'][1]->me['struct']); $logdata['Call'][1]->me['struct'] = 'Data Removed For Security'; } } $logdata['Call'][0]->me['string'] = 'APIKEY'; fputcsv(self::$handle, array( date('Y-m-d H:i:s', $logdata['Now']), $logdata['Method'], print_r(serialize($logdata['Call']), true), $logdata['Start'], $logdata['Stop'], ($logdata['Stop'] - $logdata['Start']), print_r(serialize($logdata['Result']), true), $logdata['Error'], $logdata['ErrorCode'] )); fclose(self::$handle); } public function setLog($logPath) { $this->logname = $logPath; } public function placeOrder($contactId, $creditCardId, $payPlanId, $productIds, $subscriptionIds, $processSpecials, $promoCodes, $leadAff = 0, $saleAff = 0) { $carray = array( php_xmlrpc_encode((int)$contactId), php_xmlrpc_encode((int)$creditCardId), php_xmlrpc_encode((int)$payPlanId), php_xmlrpc_encode($productIds), php_xmlrpc_encode($subscriptionIds), php_xmlrpc_encode($processSpecials), php_xmlrpc_encode($promoCodes), php_xmlrpc_encode((int)$leadAff), php_xmlrpc_encode((int)$saleAff)); return $this->methodCaller("OrderService.placeOrder", $carray); } public function getInventory($productId) { $carray = array( php_xmlrpc_encode((int)$productId)); return $this->methodCaller("ProductService.getInventory", $carray); } public function incrementInventory($productId) { $carray = array( php_xmlrpc_encode((int)$productId)); return $this->methodCaller("ProductService.incrementInventory", $carray); } function decrementInventory($productId) { $carray = array( php_xmlrpc_encode((int)$productId)); return $this->methodCaller("ProductService.decrementInventory", $carray); } public function increaseInventory($productId, $quantity) { $carray = array( php_xmlrpc_encode((int)$productId), php_xmlrpc_encode((int)$quantity)); return $this->methodCaller("ProductService.increaseInventory", $carray); } public function decreaseInventory($productId, $quantity) { $carray = array( php_xmlrpc_encode((int)$productId), php_xmlrpc_encode((int)$quantity)); return $this->methodCaller("ProductService.decreaseInventory", $carray); } public function deactivateCreditCard($creditCardId) { $carray = array( php_xmlrpc_encode((int)$creditCardId)); return $this->methodCaller("ProductService.deactivateCreditCard", $carray); } public function savedSearchAllFields($savedSearchId, $userId, $page) { $carray = array( php_xmlrpc_encode((int)$savedSearchId), php_xmlrpc_encode((int)$userId), php_xmlrpc_encode((int)$page)); return $this->methodCaller("SearchService.getSavedSearchResultsAllFields", $carray); } public function savedSearch($savedSearchId, $userId, $page, $fields) { $carray = array( php_xmlrpc_encode((int)$savedSearchId), php_xmlrpc_encode((int)$userId), php_xmlrpc_encode((int)$page), php_xmlrpc_encode($fields)); return $this->methodCaller("SearchService.getSavedSearchResults", $carray); } public function getAvailableFields($savedSearchId, $userId) { $carray = array( php_xmlrpc_encode((int)$savedSearchId), php_xmlrpc_encode((int)$userId)); return $this->methodCaller("SearchService.getAllReportColumns", $carray); } public function getDefaultQuickSearch($userId) { $carray = array( php_xmlrpc_encode((int)$userId)); return $this->methodCaller("SearchService.getDefaultQuickSearch", $carray); } public function getQuickSearches($userId) { $carray = array( php_xmlrpc_encode((int)$userId)); return $this->methodCaller("SearchService.getAvailableQuickSearches", $carray); } public function quickSearch($quickSearchType, $userId, $filterData, $page, $limit) { $carray = array( php_xmlrpc_encode($quickSearchType), php_xmlrpc_encode((int)$userId), php_xmlrpc_encode($filterData), php_xmlrpc_encode((int)$page), php_xmlrpc_encode((int)$limit)); return $this->methodCaller("SearchService.quickSearch", $carray); } public function addMoveNotes($ticketList, $moveNotes, $moveToStageId, $notifyIds) { $carray = array( php_xmlrpc_encode($ticketList), php_xmlrpc_encode($moveNotes), php_xmlrpc_encode($moveToStageId), php_xmlrpc_encode($notifyIds)); return $this->methodCaller("ServiceCallService.addMoveNotes", $carray); } public function moveTicketStage($ticketID, $ticketStage, $moveNotes, $notifyIds) { $carray = array( php_xmlrpc_encode((int)$ticketID), php_xmlrpc_encode($ticketStage), php_xmlrpc_encode($moveNotes), php_xmlrpc_encode($notifyIds)); return $this->methodCaller("ServiceCallService.moveTicketStage", $carray); } public function getAllShippingOptions() { $carray = array(); return $this->methodCaller("ShippingService.getAllShippingOptions", $carray); } public function getAllConfiguredShippingOptions() { $carray = array(); return $this->methodCaller("ShippingService.getAllShippingOptions", $carray); } public function getFlatRateShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getFlatRateShippingOption", $carray); } public function getOrderTotalShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getOrderTotalShippingOption", $carray); } public function getOrderTotalShippingRanges($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getOrderTotalShippingRanges", $carray); } public function getProductBasedShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getProductBasedShippingOption", $carray); } public function getProductShippingPricesForProductShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getProductShippingPricesForProductShippingOption", $carray); } public function getOrderQuantityShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getOrderQuantityShippingOption", $carray); } public function getWeightBasedShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getWeightBasedShippingOption", $carray); } public function getWeightBasedShippingRanges($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getWeightBasedShippingRanges", $carray); } public function getUpsShippingOption($optionId) { $carray = array( php_xmlrpc_encode((int)$optionId)); return $this->methodCaller("ShippingService.getUpsShippingOption", $carray); } public function getWebFormMap() { $carray = array(); return $this->methodCaller("WebFormService.getMap", $carray); } public function getWebFormHtml($webFormId = 0) { $carray = array( php_xmlrpc_encode((int)$webFormId)); return $this->methodCaller("WebFormService.getHTML", $carray); } public function getWebTrackingServiceTag() { $carray = array(); return $this->methodCaller("WebTrackingService.getWebTrackingScriptTag", $carray); } public function getWebTrackingScriptUrl() { $carray = array(); return $this->methodCaller("WebTrackingService.getWebTrackingScriptUrl", $carray); } } ?>